## rust-coreutils 0.1.0+git20250801.cf79675

=== debian/changelog ===
rust-coreutils (0.1.0+git20250801.cf79675-0ubuntu1) questing; urgency=medium

  * New upstream release.
    - Fixes env(1) forks, but must exec() directly (LP: #2112491)
    - Fixes cat: f.gz: EPIPE: Broken pipe (LP: #2115033)
    - Fixes date parsing does not support sub-second precision (LP: #2111603)

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 01 Aug 2025 17:10:13 +0200

rust-coreutils (0.1.0+git20250711.2ba3a33-0ubuntu4) questing; urgency=medium

  * Cherry pick mknod --mode fix (LP: #2116973)

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 29 Jul 2025 18:40:35 +0200

rust-coreutils (0.1.0+git20250711.2ba3a33-0ubuntu3) questing; urgency=medium

  * install-Fix-no-target-directory-with-existing-file.patch: Cherry pick
    my pull request to fix --no-target-directory with existing target file
    (LP: #2118785)

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 29 Jul 2025 12:17:51 +0200

rust-coreutils (0.1.0+git20250711.2ba3a33-0ubuntu2) questing; urgency=medium

  * d/b/install-mkdir-Handle-dir-.-like-dir.patch: Handle dir/./ like dir/.
    (LP: #2117466)

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 22 Jul 2025 09:48:08 +0200

rust-coreutils (0.1.0+git20250711.2ba3a33-0ubuntu1) questing; urgency=medium

  * New upstream git commit 0.1.0+git20250711.2ba3a33
    - Fix  'od' invalid handling of non ascii chars (LP: #2114827)
    - Fix `cp -a` fails to copy symlink to directory (LP: #2116859)
    - Fix dpkg-source fails to unpack broken symlink (LP: #2116886)
    - Fix Incorrect evaluation of expr (LP: #2112445)
    - Fix cat doesn't handle EPERM (LP: #2112552)
    - Fix  /bin/stty: invalid argument 'sane' (LP: #2113983)
    - Fix tee is buffered (LP: #2114706)
    - Fix rm of long paths (LP: #2114886)
    - Fix ls doesn't include acl "+" info on symlink (LP: #2114887)
    - Fix fold: failed to read line: stream did not contain valid UTF-8
      (LP: #2114970)
    - Fix  gpgrt-config invalid output due to rust-coreutils "expr"
      (LP: #2115147)
    - Fix `cp --no-dereference --parents` where source is a symlink to
      a directory (LP: #2116572)
    - Internationalization and French translations for a lot of stuff
  * Install locales
  * d/patches/Setup-localization-for-utility-symlinks.patch: Setup the
    localization when invoked via symlinks

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 21 Jul 2025 12:48:46 +0200

rust-coreutils (0.1.0-0ubuntu1) questing; urgency=medium

  * New upstream release.
    - Add the -Z,--context options (LP: #2110910)
    - Add install -T (LP: #2111714)
    - Improve echo -- handling (LP: #2115196)
    - Fixes chroot in namespace (LP: #2111882)
    - sha256sum and friends now correctly handle * (LP: #2113963)
    - rm: Don't prompt if stdin is not interactive (LP: #2115035)
  * Update vendored dependencies and rebase the patches
  * Use Rust 1.85 for building, a bunch of workarounds are needed right now:
    - Use a vendored copy of the cargo wrapper that hardcodes cargo-1.85
    - Remove the unneeded dh_auto_configure call, this duplicates what we
      already do explictly
    - Switch the build system to makefile, since we actually use the
      makefile buildsystem

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 04 Jul 2025 13:58:43 +0200

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo-1.85:native,
 rustc-1.85:native,
 libselinux1-dev,
 libclang-dev,
 python3-sphinx,
XS-Vendored-Sources-Rust: aho-corasick@1.1.3, allocator-api2@0.2.21, anes@0.1.6, ansi-width@0.1.0, anstream@0.6.19, anstyle-parse@0.2.7, anstyle-query@1.1.3, anstyle@1.0.11, array-init@2.1.0, arrayref@0.3.9, arrayvec@0.7.6, autocfg@1.4.0, bigdecimal@0.4.8, binary-heap-plus@0.5.0, bincode@2.0.1, bincode_derive@2.0.1, bindgen@0.71.1, bitflags@2.9.1, bitvec@1.0.1, blake2b_simd@1.0.3, blake3@1.8.2, block-buffer@0.10.4, bstr@1.12.0, bumpalo@3.18.1, bytecount@0.6.9, byteorder@1.5.0, cast@0.3.0, cc@1.2.27, cexpr@0.6.0, cfg-if@1.0.1, cfg_aliases@0.2.1, chrono@0.4.41, ciborium-io@0.2.2, ciborium-ll@0.2.2, ciborium@0.2.2, clang-sys@1.8.1, clap@4.5.42, clap_builder@4.5.42, clap_complete@4.5.55, clap_lex@0.7.5, clap_mangen@0.2.29, colorchoice@1.0.4, compare@0.1.0, console@0.16.0, const-random-macro@0.1.16, const-random@0.1.18, constant_time_eq@0.3.1, convert_case@0.7.1, cpufeatures@0.2.17, crc32fast@1.5.0, criterion-plot@0.5.0, criterion@0.6.0, crossbeam-deque@0.8.6, crossbeam-epoch@0.9.18, crossbeam-utils@0.8.21, crossterm@0.29.0, crunchy@0.2.3, crypto-common@0.1.6, ctor-proc-macro@0.0.6, ctor@0.4.3, ctrlc@3.4.7, data-encoding-macro-internal@0.1.16, data-encoding-macro@0.1.18, data-encoding@2.9.0, deranged@0.4.0, derive_more-impl@2.0.1, derive_more@2.0.1, diff@0.1.13, digest@0.10.7, displaydoc@0.2.5, dlv-list@0.5.2, dns-lookup@2.0.4, document-features@0.2.11, dtor-proc-macro@0.0.5, dtor@0.0.6, dunce@1.0.5, either@1.15.0, equivalent@1.0.2, errno@0.3.12, exacl@0.12.0, fastrand@2.3.0, file_diff@1.0.0, filedescriptor@0.8.3, filetime@0.2.25, fixed_decimal@0.7.0, flate2@1.1.2, fluent-bundle@0.16.0, fluent-langneg@0.13.0, fluent-syntax@0.12.0, fluent@0.17.0, fnv@1.0.7, foldhash@0.1.5, fs_extra@1.3.0, fts-sys@0.2.16, funty@2.0.0, futures-core@0.3.31, futures-macro@0.3.31, futures-task@0.3.31, futures-timer@3.0.3, futures-util@0.3.31, gcd@2.3.0, generic-array@0.14.7, getrandom@0.2.16, getrandom@0.3.3, glob@0.3.2, half@2.6.0, hashbrown@0.14.5, hashbrown@0.15.4, hex-literal@1.0.0, hex@0.4.3, hostname@0.4.1, iana-time-zone@0.1.63, icu_collator@2.0.0, icu_collator_data@2.0.0, icu_collections@2.0.0, icu_decimal@2.0.0, icu_decimal_data@2.0.0, icu_locale@2.0.0, icu_locale_core@2.0.0, icu_locale_data@2.0.0, icu_normalizer@2.0.0, icu_normalizer_data@2.0.0, icu_properties@2.0.1, icu_properties_data@2.0.1, icu_provider@2.0.0, indexmap@2.9.0, indicatif@0.18.0, inotify-sys@0.1.5, inotify@0.11.0, intl-memoizer@0.5.3, intl_pluralrules@7.0.2, is_terminal_polyfill@1.70.1, itertools@0.10.5, itertools@0.13.0, itertools@0.14.0, itoa@1.0.15, jiff@0.2.15, keccak@0.1.5, libc@0.2.174, libloading@0.8.8, libm@0.2.15, libz-rs-sys@0.5.1, linux-raw-sys@0.10.0, linux-raw-sys@0.9.4, litemap@0.8.0, litrs@0.4.1, lock_api@0.4.13, log@0.4.27, lru@0.12.5, lscolors@0.20.0, md-5@0.10.6, memchr@2.7.5, memmap2@0.9.7, memoffset@0.9.1, minimal-lexical@0.2.1, mio@1.0.4, nix@0.30.1, nom@7.1.3, nom@8.0.0, notify-types@2.0.0, notify@8.1.0, nu-ansi-term@0.50.1, num-bigint@0.4.6, num-conv@0.1.0, num-integer@0.1.46, num-modular@0.5.1, num-prime@0.4.4, num-traits@0.2.19, num_threads@0.1.7, number_prefix@0.4.0, once_cell@1.21.3, onig@6.5.1, onig_sys@69.9.1, oorandom@11.1.5, ordered-multimap@0.7.3, os_display@0.1.4, parking_lot@0.12.4, parking_lot_core@0.9.11, parse_datetime@0.11.0, phf@0.12.1, phf_codegen@0.12.1, phf_generator@0.12.1, phf_shared@0.12.1, pin-project-lite@0.2.16, pin-utils@0.1.0, pkg-config@0.3.32, platform-info@2.0.5, plotters-backend@0.3.7, plotters-svg@0.3.7, plotters@0.3.7, portable-atomic@1.11.1, potential_utf@0.1.2, powerfmt@0.2.0, ppv-lite86@0.2.21, pretty_assertions@1.4.1, prettyplease@0.2.34, proc-macro-crate@3.3.0, proc-macro2@1.0.95, quote@1.0.40, radium@0.7.0, rand@0.8.5, rand@0.9.2, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rayon-core@1.12.1, rayon@1.10.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.1, relative-path@1.9.3, rlimit@0.10.2, roff@0.2.2, rstest@0.26.1, rstest_macros@0.26.1, rust-ini@0.21.2, rustc-hash@2.1.1, rustc_version@0.4.1, rustix@1.0.7, ryu@1.0.20, same-file@1.0.6, scopeguard@1.2.0, self_cell@1.2.0, selinux-sys@0.6.14, selinux@0.5.2, semver@1.0.26, serde-big-array@0.5.1, serde@1.0.219, serde_derive@1.0.219, serde_json@1.0.140, sha1@0.10.6, sha2@0.10.9, sha3@0.10.8, shlex@1.3.0, signal-hook-mio@0.2.4, signal-hook-registry@1.4.5, signal-hook@0.3.18, simd-adler32@0.3.7, siphasher@1.0.1, slab@0.4.9, sm3@0.4.2, smallvec@1.15.1, smawk@0.3.2, socket2@0.5.10, stable_deref_trait@1.2.0, strsim@0.11.1, syn@2.0.103, synstructure@0.13.2, tap@1.0.1, tempfile@3.20.0, terminal_size@0.4.2, textwrap@0.16.2, thiserror-impl@1.0.69, thiserror-impl@2.0.12, thiserror@1.0.69, thiserror@2.0.12, time-core@0.1.4, time-macros@0.2.22, time@0.3.41, tiny-keccak@2.0.2, tinystr@0.8.1, tinytemplate@1.2.1, toml_datetime@0.6.11, toml_edit@0.22.27, type-map@0.5.1, typenum@1.18.0, unic-langid-impl@0.9.6, unic-langid@0.9.6, unicode-ident@1.0.18, unicode-linebreak@0.1.5, unicode-segmentation@1.12.0, unicode-width@0.1.14, unicode-width@0.2.1, unindent@0.2.4, unit-prefix@0.5.1, unty@0.0.4, utf16_iter@1.0.5, utf8_iter@1.0.4, utf8parse@0.2.2, uuid@1.17.0, uutils_term_grid@0.7.0, version_check@0.9.5, virtue@0.0.18, walkdir@2.5.0, wild@2.2.1, winnow@0.7.11, writeable@0.6.1, wyz@0.5.1, xattr@1.5.1, yansi@1.0.1, yoke-derive@0.8.0, yoke@0.8.0, z85@3.0.6, zerocopy@0.8.25, zerofrom-derive@0.1.6, zerofrom@0.1.6, zerotrie@0.2.2, zerovec-derive@0.11.1, zerovec@0.11.2, zip@4.3.0, zlib-rs@0.5.1, zopfli@0.8.2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export CARGO_PROFILE_RELEASE_DEBUG=true
export LIBSTDBUF_DIR = /usr/libexec/rust-coreutils
VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")
UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version|cut -d- -f1)

# Build a multicall binary instead of multiple binaries
# to reduce the storage footprint
export MULTICALL = y

# Vendoring setup
# FIXME: The upstream Makefile we use doesn't work with the cargo wrapper,
# as it assumes no cross-compilation and hence files appearing in target/release
# rather than the architecture-specific target directory.
#export CARGO = /usr/share/cargo/bin/cargo
export PATH := /usr/lib/rust-1.85/bin:$(PATH)
export CARGO_VENDOR_DIR = rust-vendor
export CARGO_HOME = $(CURDIR)/debian/cargo_home
VENDOR_TARBALL = rust-coreutils_$(UPSTREAM_VERSION).orig-$(CARGO_VENDOR_DIR).tar.xz

%:
	dh $@ --buildsystem makefile

vendor-tarball-quick-check:
	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi

vendor-deps-cargo:
	rm -rf $(CARGO_VENDOR_DIR)
	# Deliberately don't use the wrapper, as it expects the configure step
	# to have occurred already.
	# If you have to modify the path here, don't forget to change the README.source doc
	# as well.
	env -i PATH=$(PATH) cargo-vendor-filterer --all-features  --tier 2  --platform '*-*-linux-gnu' --platform '*-*-linux-gnueabi' $(CARGO_VENDOR_DIR)

vendor-deps: vendor-deps-cargo
	rm -r \
		$(CARGO_VENDOR_DIR)/*/tests
	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
	for crate in $(CARGO_VENDOR_DIR)/*; do \
		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
		done
	# Cleanup temp files
	rm -rf $(CARGO_HOME)

vendor-tarball: vendor-tarball-quick-check vendor-deps
	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)

override_dh_auto_configure:
	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) debian/cargo prepare-debian $(CARGO_VENDOR_DIR)
	/usr/share/cargo/bin/dh-cargo-vendored-sources

override_dh_auto_test:
	# for now, don't fail the build if tests are failing
	CARGO_HOME=$(CURDIR)/debian/cargo_home make PROFILE=release MULTICALL=$(MULTICALL) test||true

override_dh_auto_clean:
	debian/cargo clean
	rm -rf .cargo-checksum.json debian/cargo_registry

override_dh_auto_install:
#use thin rather than full lto on 32-bit to avoid running out of address space.
ifeq ($(DEB_HOST_ARCH_BITS),32)
	sed -i 's/lto = true/lto = "thin"/' Cargo.toml
endif
	CARGO_HOME=$(CURDIR)/debian/cargo_home DESTDIR=$(CURDIR)/debian/tmp/ make SELINUX_ENABLED=1 PROFILE=release MULTICALL=$(MULTICALL) install
ifeq ($(DEB_HOST_ARCH_BITS),32)
	sed -i 's/lto = "thin"/lto = true/' Cargo.toml
endif
# Create the symlink early to be able to generate the manpages
	cd debian/tmp/usr/share/zsh/site-functions && mkdir rust-coreutils && chmod -x _* && mv _* rust-coreutils
	cd debian/tmp/usr/share/bash-completion/completions/ && chmod -x rust-*
	cd debian/tmp/usr/share/fish/vendor_completions.d/ && chmod -x *.fish
	cd debian/tmp/usr/bin && mv rust-coreutils coreutils && rm rust-*
#	cd debian/tmp/usr/share/fish/vendor_completions.d && for f in *fish; do mv $$f rust-$$f; done
	dh_link

override_dh_missing:
	dh_missing --fail-missing

override_dh_dwz:
	# Don't do anything. fails because of the
	# https://github.com/rust-lang/rust/issues/66118

#use lower debuginfo level on 32-bit to avoid running out of address space.
ifeq ($(DEB_HOST_ARCH_BITS),32)
execute_after_dh_auto_configure:
	if test -f debian/cargo_home/config; then \
		sed -i s/debuginfo=2/debuginfo=1/ debian/cargo_home/config; \
	fi
endif

override_dh_clean:
	rm -f Cargo.toml.orig Cargo.lock
	dh_clean

## rust-coreutils 0.1.0+git20250813.4af2a84

=== debian/changelog ===
rust-coreutils (0.1.0+git20250813.4af2a84-0ubuntu4) questing; urgency=medium

  * Revert "Use Rust 1.85 for building", it is the default now
  * Use hardlinks in /usr/lib/cargo/bin instead of symlinks, this allows
    the next upload to enforce that argv[0] matches the executable name,
    such that an AppArmor profile allowing "ls" cannot be tricked into
    executing rm code by running "ls" with argv being {"rm", "..."}
  * Build verbosely

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 04 Sep 2025 12:34:06 +0200

rust-coreutils (0.1.0+git20250813.4af2a84-0ubuntu2) questing; urgency=medium

  * d/rules: Disable some more broken tests.
    These depend on the host's rust-coreutils, disable them for
    now. Forwarded upstream.

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 26 Aug 2025 21:15:42 +0200

rust-coreutils (0.1.0+git20250813.4af2a84-0ubuntu1) questing; urgency=medium

  * New upstream release.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 14 Aug 2025 16:00:22 +0200

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo:native,
 rustc:native,
 libselinux1-dev,
 libclang-dev,
 python3-sphinx,
XS-Vendored-Sources-Rust: aho-corasick@1.1.3, allocator-api2@0.2.21, anes@0.1.6, ansi-width@0.1.0, anstream@0.6.19, anstyle-parse@0.2.7, anstyle-query@1.1.3, anstyle@1.0.11, array-init@2.1.0, arrayref@0.3.9, arrayvec@0.7.6, autocfg@1.4.0, bigdecimal@0.4.8, binary-heap-plus@0.5.0, bincode@2.0.1, bincode_derive@2.0.1, bindgen@0.71.1, bitflags@2.9.1, bitvec@1.0.1, blake2b_simd@1.0.3, blake3@1.8.2, block-buffer@0.10.4, bstr@1.12.0, bumpalo@3.18.1, bytecount@0.6.9, byteorder@1.5.0, cast@0.3.0, cc@1.2.27, cexpr@0.6.0, cfg-if@1.0.1, cfg_aliases@0.2.1, chrono@0.4.41, ciborium-io@0.2.2, ciborium-ll@0.2.2, ciborium@0.2.2, clang-sys@1.8.1, clap@4.5.45, clap_builder@4.5.44, clap_complete@4.5.57, clap_lex@0.7.5, clap_mangen@0.2.29, colorchoice@1.0.4, compare@0.1.0, console@0.16.0, const-random-macro@0.1.16, const-random@0.1.18, constant_time_eq@0.3.1, convert_case@0.7.1, cpufeatures@0.2.17, crc32fast@1.5.0, criterion-plot@0.5.0, criterion@0.6.0, crossbeam-deque@0.8.6, crossbeam-epoch@0.9.18, crossbeam-utils@0.8.21, crossterm@0.29.0, crunchy@0.2.3, crypto-common@0.1.6, ctor-proc-macro@0.0.6, ctor@0.5.0, ctrlc@3.4.7, data-encoding-macro-internal@0.1.16, data-encoding-macro@0.1.18, data-encoding@2.9.0, deranged@0.4.0, derive_more-impl@2.0.1, derive_more@2.0.1, diff@0.1.13, digest@0.10.7, displaydoc@0.2.5, dlv-list@0.5.2, dns-lookup@2.1.0, document-features@0.2.11, dtor-proc-macro@0.0.6, dtor@0.1.0, dunce@1.0.5, either@1.15.0, equivalent@1.0.2, errno@0.3.12, exacl@0.12.0, fastrand@2.3.0, file_diff@1.0.0, filedescriptor@0.8.3, filetime@0.2.25, fixed_decimal@0.7.0, flate2@1.1.2, fluent-bundle@0.16.0, fluent-langneg@0.13.0, fluent-syntax@0.12.0, fluent@0.17.0, fnv@1.0.7, foldhash@0.1.5, fs_extra@1.3.0, fts-sys@0.2.16, funty@2.0.0, futures-core@0.3.31, futures-macro@0.3.31, futures-task@0.3.31, futures-timer@3.0.3, futures-util@0.3.31, gcd@2.3.0, generic-array@0.14.7, getrandom@0.2.16, getrandom@0.3.3, glob@0.3.3, half@2.6.0, hashbrown@0.14.5, hashbrown@0.15.4, hex-literal@1.0.0, hex@0.4.3, hostname@0.4.1, iana-time-zone@0.1.63, icu_collator@2.0.0, icu_collator_data@2.0.0, icu_collections@2.0.0, icu_decimal@2.0.0, icu_decimal_data@2.0.0, icu_locale@2.0.0, icu_locale_core@2.0.0, icu_locale_data@2.0.0, icu_normalizer@2.0.0, icu_normalizer_data@2.0.0, icu_properties@2.0.1, icu_properties_data@2.0.1, icu_provider@2.0.0, indexmap@2.9.0, indicatif@0.18.0, inotify-sys@0.1.5, inotify@0.11.0, intl-memoizer@0.5.3, intl_pluralrules@7.0.2, is_terminal_polyfill@1.70.1, itertools@0.10.5, itertools@0.13.0, itertools@0.14.0, itoa@1.0.15, jiff@0.2.15, keccak@0.1.5, libc@0.2.175, libloading@0.8.8, libm@0.2.15, libz-rs-sys@0.5.1, linux-raw-sys@0.10.0, linux-raw-sys@0.9.4, litemap@0.8.0, litrs@0.4.1, lock_api@0.4.13, log@0.4.27, lru@0.12.5, lscolors@0.20.0, md-5@0.10.6, memchr@2.7.5, memmap2@0.9.7, memoffset@0.9.1, minimal-lexical@0.2.1, mio@1.0.4, nix@0.30.1, nom@7.1.3, nom@8.0.0, notify-types@2.0.0, notify@8.2.0, nu-ansi-term@0.50.1, num-bigint@0.4.6, num-conv@0.1.0, num-integer@0.1.46, num-modular@0.5.1, num-prime@0.4.4, num-traits@0.2.19, num_threads@0.1.7, number_prefix@0.4.0, once_cell@1.21.3, onig@6.5.1, onig_sys@69.9.1, oorandom@11.1.5, ordered-multimap@0.7.3, os_display@0.1.4, parking_lot@0.12.4, parking_lot_core@0.9.11, parse_datetime@0.11.0, phf@0.12.1, phf_codegen@0.12.1, phf_generator@0.12.1, phf_shared@0.12.1, pin-project-lite@0.2.16, pin-utils@0.1.0, pkg-config@0.3.32, platform-info@2.0.5, plotters-backend@0.3.7, plotters-svg@0.3.7, plotters@0.3.7, portable-atomic@1.11.1, potential_utf@0.1.2, powerfmt@0.2.0, ppv-lite86@0.2.21, pretty_assertions@1.4.1, prettyplease@0.2.34, proc-macro-crate@3.3.0, proc-macro2@1.0.97, quote@1.0.40, radium@0.7.0, rand@0.8.5, rand@0.9.2, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rayon-core@1.13.0, rayon@1.11.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.1, relative-path@1.9.3, rlimit@0.10.2, roff@0.2.2, rstest@0.26.1, rstest_macros@0.26.1, rust-ini@0.21.2, rustc-hash@2.1.1, rustc_version@0.4.1, rustix@1.0.7, ryu@1.0.20, same-file@1.0.6, scopeguard@1.2.0, self_cell@1.2.0, selinux-sys@0.6.14, selinux@0.5.2, semver@1.0.26, serde-big-array@0.5.1, serde@1.0.219, serde_derive@1.0.219, serde_json@1.0.140, sha1@0.10.6, sha2@0.10.9, sha3@0.10.8, shlex@1.3.0, signal-hook-mio@0.2.4, signal-hook-registry@1.4.5, signal-hook@0.3.18, simd-adler32@0.3.7, siphasher@1.0.1, slab@0.4.9, sm3@0.4.2, smallvec@1.15.1, smawk@0.3.2, socket2@0.6.0, stable_deref_trait@1.2.0, strsim@0.11.1, syn@2.0.103, synstructure@0.13.2, tap@1.0.1, tempfile@3.20.0, terminal_size@0.4.3, textwrap@0.16.2, thiserror-impl@1.0.69, thiserror-impl@2.0.14, thiserror@1.0.69, thiserror@2.0.14, time-core@0.1.4, time-macros@0.2.22, time@0.3.41, tiny-keccak@2.0.2, tinystr@0.8.1, tinytemplate@1.2.1, toml_datetime@0.6.11, toml_edit@0.22.27, type-map@0.5.1, typenum@1.18.0, unic-langid-impl@0.9.6, unic-langid@0.9.6, unicode-ident@1.0.18, unicode-linebreak@0.1.5, unicode-segmentation@1.12.0, unicode-width@0.1.14, unicode-width@0.2.1, unindent@0.2.4, unit-prefix@0.5.1, unty@0.0.4, utf16_iter@1.0.5, utf8_iter@1.0.4, utf8parse@0.2.2, uuid@1.17.0, uutils_term_grid@0.7.0, version_check@0.9.5, virtue@0.0.18, walkdir@2.5.0, wild@2.2.1, winnow@0.7.11, writeable@0.6.1, wyz@0.5.1, xattr@1.5.1, yansi@1.0.1, yoke-derive@0.8.0, yoke@0.8.0, z85@3.0.6, zerocopy@0.8.25, zerofrom-derive@0.1.6, zerofrom@0.1.6, zerotrie@0.2.2, zerovec-derive@0.11.1, zerovec@0.11.2, zip@4.3.0, zlib-rs@0.5.1, zopfli@0.8.2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.

=== debian/rules ===
--- 
+++ 
@@ -18,13 +18,16 @@
 # as it assumes no cross-compilation and hence files appearing in target/release
 # rather than the architecture-specific target directory.
 #export CARGO = /usr/share/cargo/bin/cargo
-export PATH := /usr/lib/rust-1.85/bin:$(PATH)
 export CARGO_VENDOR_DIR = rust-vendor
 export CARGO_HOME = $(CURDIR)/debian/cargo_home
+
+# Build verbosely
+export CARGOFLAGS = -v
+
 VENDOR_TARBALL = rust-coreutils_$(UPSTREAM_VERSION).orig-$(CARGO_VENDOR_DIR).tar.xz
 
 %:
-	dh $@ --buildsystem makefile
+	dh $@ --buildsystem cargo
 
 vendor-tarball-quick-check:
 	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi
@@ -35,7 +38,7 @@
 	# to have occurred already.
 	# If you have to modify the path here, don't forget to change the README.source doc
 	# as well.
-	env -i PATH=$(PATH) cargo-vendor-filterer --all-features  --tier 2  --platform '*-*-linux-gnu' --platform '*-*-linux-gnueabi' $(CARGO_VENDOR_DIR)
+	env -i cargo-vendor-filterer --all-features  --tier 2  --platform '*-*-linux-gnu' --platform '*-*-linux-gnueabi' $(CARGO_VENDOR_DIR)
 
 vendor-deps: vendor-deps-cargo
 	rm -r \
@@ -51,16 +54,37 @@
 	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)
 
 override_dh_auto_configure:
-	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) debian/cargo prepare-debian $(CARGO_VENDOR_DIR)
+	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian $(CARGO_VENDOR_DIR)
 	/usr/share/cargo/bin/dh-cargo-vendored-sources
+	dh_auto_configure
 
 override_dh_auto_test:
-	# for now, don't fail the build if tests are failing
-	CARGO_HOME=$(CURDIR)/debian/cargo_home make PROFILE=release MULTICALL=$(MULTICALL) test||true
-
-override_dh_auto_clean:
-	debian/cargo clean
-	rm -rf .cargo-checksum.json debian/cargo_registry
+	CARGO_HOME=$(CURDIR)/debian/cargo_home make PROFILE=release MULTICALL=$(MULTICALL) \
+				TEST_NO_FAIL_FAST="-- --skip test_env::test_env_arg_ignore_signal_valid_signals \
+				--skip test_env::test_simulation_of_terminal_for_stdin_only \
+				--skip test_simulation_of_terminal_size_information \
+				--skip test_simulation_of_terminal_true \
+				--skip test_device_number \
+				--skip test_expr::test_long_input \
+				--skip test_factor::test_parallel \
+				--skip test_install::test_install_and_strip \
+				--skip test_install::test_install_and_strip_with_program \
+				--skip test_od::test_suppress_duplicates \
+				--skip test_stat::test_fs_format \
+				--skip test_stat::test_multi_files \
+				--skip test_stat::test_normal_format \
+				--skip test_stat::test_printf \
+				--skip test_stat::test_symlinks \
+				--skip test_stat::test_terse_fs_format \
+				--skip test_stdbuf::test_libstdbuf_preload \
+				--skip test_stdbuf::test_no_such \
+				--skip test_stdbuf::test_permission \
+				--skip test_stdbuf::test_stdbuf_line_buffered_stdout \
+				--skip test_stdbuf::test_stdbuf_trailing_var_arg \
+				--skip test_stdbuf::test_stdbuf_unbuffered_stdout \
+				--skip test_who::test_boot \
+				--skip test_tail::test_following_with_pid" \
+				test
 
 override_dh_auto_install:
 #use thin rather than full lto on 32-bit to avoid running out of address space.
@@ -77,7 +101,12 @@
 	cd debian/tmp/usr/share/fish/vendor_completions.d/ && chmod -x *.fish
 	cd debian/tmp/usr/bin && mv rust-coreutils coreutils && rm rust-*
 #	cd debian/tmp/usr/share/fish/vendor_completions.d && for f in *fish; do mv $$f rust-$$f; done
-	dh_link
+#
+execute_after_dh_install:
+	install -d debian/rust-coreutils/usr/lib/cargo/bin/coreutils
+	cat debian/rust-coreutils.hardlinks | while read a b; do \
+		env -C debian/rust-coreutils/ ln $$a $$b; \
+	done
 
 override_dh_missing:
 	dh_missing --fail-missing

## rust-coreutils 0.2.2

=== Makefile ===
UseGNU=gmake $*
all:
	@$(UseGNU)
.DEFAULT:
	@$(UseGNU)

=== docs/Makefile ===
clean:
	rm -rf book
	rm -f src/SUMMARY.md
	rm -f src/utils/*

=== debian/changelog ===
rust-coreutils (0.2.2-0ubuntu2) questing; urgency=medium

  * id: Implement no-op `-a` option (LP: #2125578)

 -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 24 Sep 2025 17:36:56 +0200

rust-coreutils (0.2.2-0ubuntu1) questing; urgency=medium

  * New upstream release.

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 23 Sep 2025 17:17:36 +0200

rust-coreutils (0.1.0+git20250813.4af2a84-0ubuntu7) questing; urgency=medium

  * stty: avoid panic when not attached to a tty.
    This was causing additional stderr output in tests using
    xvfb-run, causing the tests to fail.
    (The *command* itself was failing regardless, but the failure
    case here is that the shell printed the "Aborted (core dumped)"
    messages)
  * Cherry-pick https://github.com/uutils/coreutils/pull/8565
  * Refresh 8565 to make it a "proper" patch that only patches each file once

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 09 Sep 2025 18:54:54 +0200

rust-coreutils (0.1.0+git20250813.4af2a84-0ubuntu6) questing; urgency=medium

  * Handle speed_t changes in glibc 2.42 (LP: #2121635)

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 04 Sep 2025 23:32:09 +0200

rust-coreutils (0.1.0+git20250813.4af2a84-0ubuntu5) questing; urgency=medium

  * Require utilities to be invoked using matching path.
    Ensure that argv[0] if it is a utility name matches /proc/self/exe
    if /proc/self/exe exists. This allows AppArmor transitions to have
    reasonable effect; for example transitioning to unconfined ls cannot
    inadvertently run `rm` code.
  * Conflict with coreutils-from-uutils that linked to /usr/bin/coreutils.
    Symlinks to /usr/bin/coreutils no longer work in the new scheme,
    so we need a versioned Conflicts to force the symlinks to be
    updated first *before* we unpack the new enforcing rust-coreutils

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 04 Sep 2025 22:17:05 +0200

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo:native,
 rustc:native,
 libselinux1-dev,
 libclang-dev,
 python3-sphinx,
XS-Vendored-Sources-Rust: aho-corasick@1.1.3, allocator-api2@0.2.21, anes@0.1.6, ansi-width@0.1.0, anstream@0.6.19, anstyle-parse@0.2.7, anstyle-query@1.1.3, anstyle@1.0.11, array-init@2.1.0, arrayref@0.3.9, arrayvec@0.7.6, autocfg@1.4.0, base64-simd@0.8.0, bigdecimal@0.4.8, binary-heap-plus@0.5.0, bincode@2.0.1, bincode_derive@2.0.1, bindgen@0.71.1, bitflags@2.9.1, bitvec@1.0.1, blake2b_simd@1.0.3, blake3@1.8.2, block-buffer@0.10.4, bstr@1.12.0, bumpalo@3.18.1, bytecount@0.6.9, byteorder@1.5.0, cast@0.3.0, cc@1.2.27, cexpr@0.6.0, cfg-if@1.0.1, cfg_aliases@0.2.1, chrono@0.4.42, ciborium-io@0.2.2, ciborium-ll@0.2.2, ciborium@0.2.2, clang-sys@1.8.1, clap@4.5.47, clap_builder@4.5.47, clap_complete@4.5.57, clap_lex@0.7.5, clap_mangen@0.2.29, colorchoice@1.0.4, compare@0.1.0, console@0.16.0, const-random-macro@0.1.16, const-random@0.1.18, constant_time_eq@0.3.1, convert_case@0.7.1, cpufeatures@0.2.17, crc32fast@1.5.0, criterion-plot@0.5.0, criterion@0.6.0, crossbeam-deque@0.8.6, crossbeam-epoch@0.9.18, crossbeam-utils@0.8.21, crossterm@0.29.0, crunchy@0.2.3, crypto-common@0.1.6, ctor-proc-macro@0.0.6, ctor@0.5.0, ctrlc@3.4.7, data-encoding-macro-internal@0.1.16, data-encoding-macro@0.1.18, data-encoding@2.9.0, deranged@0.5.2, derive_more-impl@2.0.1, derive_more@2.0.1, diff@0.1.13, digest@0.10.7, displaydoc@0.2.5, dlv-list@0.5.2, dns-lookup@3.0.0, document-features@0.2.11, dtor-proc-macro@0.0.6, dtor@0.1.0, dunce@1.0.5, either@1.15.0, equivalent@1.0.2, errno@0.3.12, exacl@0.12.0, fastrand@2.3.0, file_diff@1.0.0, filedescriptor@0.8.3, filetime@0.2.26, fixed_decimal@0.7.0, flate2@1.1.2, fluent-bundle@0.16.0, fluent-langneg@0.13.0, fluent-syntax@0.12.0, fluent@0.17.0, fnv@1.0.7, foldhash@0.1.5, fs_extra@1.3.0, fts-sys@0.2.16, funty@2.0.0, futures-core@0.3.31, futures-macro@0.3.31, futures-task@0.3.31, futures-timer@3.0.3, futures-util@0.3.31, gcd@2.3.0, generic-array@0.14.7, getrandom@0.2.16, getrandom@0.3.3, glob@0.3.3, half@2.6.0, hashbrown@0.14.5, hashbrown@0.15.4, hex-literal@1.0.0, hex@0.4.3, hostname@0.4.1, iana-time-zone@0.1.63, icu_collator@2.0.0, icu_collator_data@2.0.0, icu_collections@2.0.0, icu_decimal@2.0.0, icu_decimal_data@2.0.0, icu_locale@2.0.0, icu_locale_core@2.0.0, icu_locale_data@2.0.0, icu_normalizer@2.0.0, icu_normalizer_data@2.0.0, icu_properties@2.0.1, icu_properties_data@2.0.1, icu_provider@2.0.0, indexmap@2.9.0, indicatif@0.18.0, inotify-sys@0.1.5, inotify@0.11.0, intl-memoizer@0.5.3, intl_pluralrules@7.0.2, is_terminal_polyfill@1.70.1, itertools@0.10.5, itertools@0.13.0, itertools@0.14.0, itoa@1.0.15, jiff@0.2.15, keccak@0.1.5, libc@0.2.175, libloading@0.8.8, libm@0.2.15, libz-rs-sys@0.5.1, linux-raw-sys@0.11.0, linux-raw-sys@0.9.4, litemap@0.8.0, litrs@0.4.1, lock_api@0.4.13, log@0.4.27, lru@0.12.5, lscolors@0.20.0, md-5@0.10.6, memchr@2.7.5, memmap2@0.9.8, memoffset@0.9.1, minimal-lexical@0.2.1, mio@1.0.4, nix@0.30.1, nom@7.1.3, nom@8.0.0, notify-types@2.0.0, notify@8.2.0, nu-ansi-term@0.50.1, num-bigint@0.4.6, num-conv@0.1.0, num-integer@0.1.46, num-modular@0.5.1, num-prime@0.4.4, num-traits@0.2.19, num_threads@0.1.7, number_prefix@0.4.0, once_cell@1.21.3, onig@6.5.1, onig_sys@69.9.1, oorandom@11.1.5, ordered-multimap@0.7.3, os_display@0.1.4, outref@0.5.2, parking_lot@0.12.4, parking_lot_core@0.9.11, parse_datetime@0.11.0, phf@0.13.1, phf_codegen@0.13.1, phf_generator@0.13.1, phf_shared@0.13.1, pin-project-lite@0.2.16, pin-utils@0.1.0, pkg-config@0.3.32, platform-info@2.0.5, plotters-backend@0.3.7, plotters-svg@0.3.7, plotters@0.3.7, portable-atomic@1.11.1, potential_utf@0.1.2, powerfmt@0.2.0, ppv-lite86@0.2.21, pretty_assertions@1.4.1, prettyplease@0.2.34, proc-macro-crate@3.3.0, proc-macro2@1.0.101, quote@1.0.40, radium@0.7.0, rand@0.8.5, rand@0.9.2, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rayon-core@1.13.0, rayon@1.11.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.2, relative-path@1.9.3, rlimit@0.10.2, roff@0.2.2, rstest@0.26.1, rstest_macros@0.26.1, rust-ini@0.21.3, rustc-hash@2.1.1, rustc_version@0.4.1, rustix@1.0.7, ryu@1.0.20, same-file@1.0.6, scopeguard@1.2.0, self_cell@1.2.0, selinux-sys@0.6.14, selinux@0.5.2, semver@1.0.26, serde-big-array@0.5.1, serde@1.0.219, serde_derive@1.0.219, serde_json@1.0.140, sha1@0.10.6, sha2@0.10.9, sha3@0.10.8, shlex@1.3.0, signal-hook-mio@0.2.4, signal-hook-registry@1.4.5, signal-hook@0.3.18, simd-adler32@0.3.7, siphasher@1.0.1, slab@0.4.9, sm3@0.4.2, smallvec@1.15.1, smawk@0.3.2, socket2@0.6.0, stable_deref_trait@1.2.0, strsim@0.11.1, syn@2.0.103, synstructure@0.13.2, tap@1.0.1, tempfile@3.21.0, terminal_size@0.4.3, textwrap@0.16.2, thiserror-impl@1.0.69, thiserror-impl@2.0.16, thiserror@1.0.69, thiserror@2.0.16, time-core@0.1.6, time-macros@0.2.24, time@0.3.43, tiny-keccak@2.0.2, tinystr@0.8.1, tinytemplate@1.2.1, toml_datetime@0.6.11, toml_edit@0.22.27, type-map@0.5.1, typenum@1.18.0, unic-langid-impl@0.9.6, unic-langid@0.9.6, unicode-ident@1.0.18, unicode-linebreak@0.1.5, unicode-segmentation@1.12.0, unicode-width@0.1.14, unicode-width@0.2.1, unindent@0.2.4, unit-prefix@0.5.1, unty@0.0.4, utf16_iter@1.0.5, utf8_iter@1.0.4, utf8parse@0.2.2, uuid@1.17.0, uutils_term_grid@0.7.0, version_check@0.9.5, virtue@0.0.18, vsimd@0.8.0, walkdir@2.5.0, wild@2.2.1, winnow@0.7.11, writeable@0.6.1, wyz@0.5.1, xattr@1.5.1, yansi@1.0.1, yoke-derive@0.8.0, yoke@0.8.0, z85@3.0.6, zerocopy@0.8.25, zerofrom-derive@0.1.6, zerofrom@0.1.6, zerotrie@0.2.2, zerovec-derive@0.11.1, zerovec@0.11.2, zip@5.0.0, zlib-rs@0.5.1, zopfli@0.8.2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Conflicts:
 coreutils-from-uutils (<< 0.0.0~ubuntu22~)
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.

## rust-coreutils 0.3.0

=== codspeed/instrument-hooks/example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(instrument-hooks-example C)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)

# Define the instrument_hooks library
add_library(
    instrument_hooks
    STATIC
    ${CMAKE_CURRENT_SOURCE_DIR}/instrument-hooks/dist/core.c
)

target_include_directories(
    instrument_hooks
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/instrument-hooks/includes>
    $<INSTALL_INTERFACE:includes>
)

# Suppress warnings for the instrument_hooks library
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    target_compile_options(
        instrument_hooks
        PRIVATE
        -Wno-maybe-uninitialized
        -Wno-unused-variable
        -Wno-unused-parameter
        -Wno-unused-but-set-variable
        -Wno-type-limits
    )
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(
        instrument_hooks
        PRIVATE
        /wd4101  # unreferenced local variable (equivalent to -Wno-unused-variable)
        /wd4189  # local variable is initialized but not referenced (equivalent to -Wno-unused-but-set-variable)
        /wd4100  # unreferenced formal parameter (equivalent to -Wno-unused-parameter)
        /wd4245  # signed/unsigned mismatch
        /wd4132  # const object should be initialized
        /wd4146  # unary minus operator applied to unsigned type
    )
endif()

# Example executable
add_executable(example main.c)
target_link_libraries(example instrument_hooks)

# Treat warnings as errors for the example
if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
    target_compile_options(example PRIVATE -Wall -Wextra -Werror)
elseif(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(example PRIVATE /W4 /WX)
endif()

=== debian/changelog ===
rust-coreutils (0.3.0-0ubuntu2) resolute; urgency=medium

  * Skip failing 0.3.0 tests
    https://github.com/uutils/coreutils/issues/9017

 -- Julian Andres Klode <juliank@ubuntu.com>  Sat, 25 Oct 2025 15:23:12 +0200

rust-coreutils (0.3.0-0ubuntu1) resolute; urgency=medium

  * New upstream release.
  * Drop applied patches:
    - date: use reference file (LP: #2127970)
    - id: Implement no-op `-a` option (LP: #2125578)

 -- Julian Andres Klode <juliank@ubuntu.com>  Sat, 25 Oct 2025 15:13:36 +0200

rust-coreutils (0.2.2-0ubuntu4) resolute; urgency=medium

  * Cherry pick fixes from pull requests
    - date: use reference file (LP: #2127970)
    - dd: ensure full writes (LP: #2125535)

 -- Julian Andres Klode <juliank@ubuntu.com>  Wed, 22 Oct 2025 12:39:11 +0200

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo:native,
 rustc:native,
 libselinux1-dev,
 libclang-dev,
 python3-sphinx,
XS-Vendored-Sources-Rust: adler2@2.0.1, aho-corasick@1.1.3, allocator-api2@0.2.21, anes@0.1.6, ansi-width@0.1.0, anstream@0.6.19, anstyle-parse@0.2.7, anstyle-query@1.1.3, anstyle@1.0.11, anyhow@1.0.100, approx@0.5.1, array-init@2.1.0, arrayref@0.3.9, arrayvec@0.7.6, autocfg@1.4.0, base64-simd@0.8.0, bigdecimal@0.4.9, binary-heap-plus@0.5.0, bincode@2.0.1, bincode_derive@2.0.1, bindgen@0.72.1, bitflags@2.9.1, bitvec@1.0.1, blake2b_simd@1.0.3, blake3@1.8.2, block-buffer@0.10.4, bstr@1.12.0, bumpalo@3.18.1, bytecount@0.6.9, byteorder@1.5.0, cast@0.3.0, cc@1.2.27, cexpr@0.6.0, cfg-if@1.0.1, cfg_aliases@0.2.1, chrono@0.4.42, ciborium-io@0.2.2, ciborium-ll@0.2.2, ciborium@0.2.2, clang-sys@1.8.1, clap@4.5.50, clap_builder@4.5.50, clap_complete@4.5.59, clap_lex@0.7.5, clap_mangen@0.2.31, codspeed-divan-compat-macros@4.0.5, codspeed-divan-compat-walltime@4.0.5, codspeed-divan-compat@4.0.5, codspeed@4.0.5, colorchoice@1.0.4, colored@2.2.0, compare@0.1.0, condtype@1.3.0, console@0.16.0, const-random-macro@0.1.16, const-random@0.1.18, constant_time_eq@0.3.1, convert_case@0.7.1, cpufeatures@0.2.17, crc-catalog@2.4.0, crc-fast@1.5.0, crc32fast@1.5.0, crc@3.3.0, criterion-plot@0.5.0, criterion@0.6.0, crossbeam-deque@0.8.6, crossbeam-epoch@0.9.18, crossbeam-utils@0.8.21, crossterm@0.29.0, crunchy@0.2.3, crypto-common@0.1.6, ctor-proc-macro@0.0.7, ctor@0.6.0, ctrlc@3.4.7, data-encoding-macro-internal@0.1.16, data-encoding-macro@0.1.18, data-encoding@2.9.0, deranged@0.5.2, derive_more-impl@2.0.1, derive_more@2.0.1, diff@0.1.13, digest@0.10.7, displaydoc@0.2.5, divan-macros@0.1.17, dlv-list@0.5.2, dns-lookup@3.0.1, document-features@0.2.11, dtor-proc-macro@0.0.6, dtor@0.1.0, dunce@1.0.5, either@1.15.0, equivalent@1.0.2, errno@0.3.12, exacl@0.12.0, fastrand@2.3.0, file_diff@1.0.0, filedescriptor@0.8.3, filetime@0.2.26, fixed_decimal@0.7.0, flate2@1.1.2, fluent-bundle@0.16.0, fluent-langneg@0.13.0, fluent-syntax@0.12.0, fluent@0.17.0, fnv@1.0.7, foldhash@0.1.5, fs_extra@1.3.0, fts-sys@0.2.17, funty@2.0.0, futures-core@0.3.31, futures-macro@0.3.31, futures-task@0.3.31, futures-timer@3.0.3, futures-util@0.3.31, gcd@2.3.0, generic-array@0.14.7, getrandom@0.2.16, getrandom@0.3.3, glob@0.3.3, half@2.7.1, hashbrown@0.14.5, hashbrown@0.15.4, hex-literal@1.0.0, hex@0.4.3, hostname@0.4.1, iana-time-zone@0.1.63, icu_collator@2.0.0, icu_collator_data@2.0.0, icu_collections@2.0.0, icu_decimal@2.0.0, icu_decimal_data@2.0.0, icu_locale@2.0.0, icu_locale_core@2.0.0, icu_locale_data@2.0.0, icu_normalizer@2.0.0, icu_normalizer_data@2.0.0, icu_properties@2.0.1, icu_properties_data@2.0.1, icu_provider@2.0.0, indexmap@2.9.0, indicatif@0.18.1, inotify-sys@0.1.5, inotify@0.11.0, intl-memoizer@0.5.3, intl_pluralrules@7.0.2, is_terminal_polyfill@1.70.1, itertools@0.10.5, itertools@0.13.0, itertools@0.14.0, itoa@1.0.15, jiff@0.2.15, keccak@0.1.5, lazy_static@1.5.0, libc@0.2.175, libloading@0.8.8, libm@0.2.15, libz-rs-sys@0.5.1, linux-raw-sys@0.11.0, litemap@0.8.0, litrs@0.4.1, lock_api@0.4.13, log@0.4.27, lru@0.12.5, lscolors@0.21.0, md-5@0.10.6, memchr@2.7.6, memmap2@0.9.9, memoffset@0.9.1, minimal-lexical@0.2.1, miniz_oxide@0.8.9, mio@1.0.4, nix@0.30.1, nom@7.1.3, nom@8.0.0, notify-types@2.0.0, notify@8.2.0, nu-ansi-term@0.50.3, num-bigint@0.4.6, num-conv@0.1.0, num-integer@0.1.46, num-modular@0.5.1, num-prime@0.4.4, num-traits@0.2.19, num_threads@0.1.7, number_prefix@0.4.0, once_cell@1.21.3, onig@6.5.1, onig_sys@69.9.1, oorandom@11.1.5, ordered-multimap@0.7.3, os_display@0.1.4, outref@0.5.2, parking_lot@0.12.4, parking_lot_core@0.9.11, parse_datetime@0.11.0, phf@0.13.1, phf_codegen@0.13.1, phf_generator@0.13.1, phf_shared@0.13.1, pin-project-lite@0.2.16, pin-utils@0.1.0, pkg-config@0.3.32, platform-info@2.0.5, plotters-backend@0.3.7, plotters-svg@0.3.7, plotters@0.3.7, portable-atomic@1.11.1, potential_utf@0.1.2, powerfmt@0.2.0, ppv-lite86@0.2.21, pretty_assertions@1.4.1, prettyplease@0.2.34, proc-macro-crate@3.3.0, proc-macro2@1.0.103, procfs-core@0.18.0, procfs@0.18.0, quote@1.0.41, radium@0.7.0, rand@0.8.5, rand@0.9.2, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rayon-core@1.13.0, rayon@1.11.0, regex-automata@0.4.12, regex-lite@0.1.7, regex-syntax@0.8.5, regex@1.12.2, relative-path@1.9.3, rlimit@0.10.2, roff@0.2.2, rstest@0.26.1, rstest_macros@0.26.1, rust-ini@0.21.3, rustc-hash@2.1.1, rustc_version@0.4.1, rustix@1.1.2, rustversion@1.0.21, ryu@1.0.20, same-file@1.0.6, scopeguard@1.2.0, self_cell@1.2.1, selinux-sys@0.6.15, selinux@0.5.2, semver@1.0.26, serde-big-array@0.5.1, serde@1.0.228, serde_core@1.0.228, serde_derive@1.0.228, serde_json@1.0.140, sha1@0.10.6, sha2@0.10.9, sha3@0.10.8, shlex@1.3.0, signal-hook-mio@0.2.4, signal-hook-registry@1.4.5, signal-hook@0.3.18, simd-adler32@0.3.7, siphasher@1.0.1, slab@0.4.9, sm3@0.4.2, smallvec@1.15.1, smawk@0.3.2, socket2@0.6.0, stable_deref_trait@1.2.0, statrs@0.18.0, strsim@0.11.1, syn@2.0.103, synstructure@0.13.2, tap@1.0.1, tempfile@3.23.0, terminal_size@0.4.3, textwrap@0.16.2, thiserror-impl@1.0.69, thiserror-impl@2.0.17, thiserror@1.0.69, thiserror@2.0.17, time-core@0.1.6, time-macros@0.2.24, time@0.3.44, tiny-keccak@2.0.2, tinystr@0.8.1, tinytemplate@1.2.1, toml_datetime@0.6.11, toml_edit@0.22.27, type-map@0.5.1, typenum@1.18.0, unic-langid-impl@0.9.6, unic-langid@0.9.6, unicode-ident@1.0.18, unicode-linebreak@0.1.5, unicode-segmentation@1.12.0, unicode-width@0.1.14, unicode-width@0.2.2, unindent@0.2.4, unit-prefix@0.5.1, unty@0.0.4, utf16_iter@1.0.5, utf8_iter@1.0.4, utf8parse@0.2.2, uuid@1.17.0, uutils_term_grid@0.7.0, version_check@0.9.5, virtue@0.0.18, vsimd@0.8.0, walkdir@2.5.0, wild@2.2.1, winnow@0.7.11, writeable@0.6.1, wyz@0.5.1, xattr@1.6.1, yansi@1.0.1, yoke-derive@0.8.0, yoke@0.8.0, z85@3.0.6, zerocopy-derive@0.8.27, zerocopy@0.8.27, zerofrom-derive@0.1.6, zerofrom@0.1.6, zerotrie@0.2.2, zerovec-derive@0.11.1, zerovec@0.11.2, zip@6.0.0, zlib-rs@0.5.1, zopfli@0.8.2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Conflicts:
 coreutils-from-uutils (<< 0.0.0~ubuntu22~)
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.

=== debian/rules ===
--- 
+++ 
@@ -64,13 +64,21 @@
 				--skip test_env::test_simulation_of_terminal_for_stdin_only \
 				--skip test_simulation_of_terminal_size_information \
 				--skip test_simulation_of_terminal_true \
-				--skip test_device_number \
 				--skip test_expr::test_long_input \
 				--skip test_factor::test_parallel \
+				--skip test_chown::test_chown_only_group_id_nonexistent_group \
+				--skip test_chown::test_chown_only_user_id_nonexistent_user \
 				--skip test_install::test_install_and_strip \
 				--skip test_install::test_install_and_strip_with_program \
+				--skip test_install::test_install_root_combined \
+				--skip test_od::test_od_options_after_filename \
 				--skip test_od::test_suppress_duplicates \
+				--skip test_pinky::test_no_flag \
+				--skip test_pinky::test_short_format_i \
+				--skip test_pinky::test_short_format_q \
 				--skip test_stat::test_fs_format \
+				--skip test_stat::test_mount_point_basic \
+				--skip test_stat::test_mount_point_combined_with_other_specifiers \
 				--skip test_stat::test_multi_files \
 				--skip test_stat::test_normal_format \
 				--skip test_stat::test_printf \
@@ -80,10 +88,11 @@
 				--skip test_stdbuf::test_no_such \
 				--skip test_stdbuf::test_permission \
 				--skip test_stdbuf::test_stdbuf_line_buffered_stdout \
+				--skip test_stdbuf::test_stdbuf_non_utf8_paths \
 				--skip test_stdbuf::test_stdbuf_trailing_var_arg \
 				--skip test_stdbuf::test_stdbuf_unbuffered_stdout \
 				--skip test_who::test_boot \
-				--skip test_tail::test_following_with_pid" \
+				--skip util_invalid_name_invalid_command" \
 				test
 
 override_dh_auto_install:
